#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <stdio.h>
#include <string.h>
#include <psprtc.h>
#include <math.h>
#include <psprtc.h>
#include "../common/old/callbacks.c"
#include "../common/printstuff.c"

PSP_MODULE_INFO("G.G.L.I.", 0, 1, 1);

SceCtrlData		pad;
u32			oldButtons;
int			board[67][34][2], down[68], oneHere[68], speed, mode;
unsigned long	colors[11];
char			myMessage[999], message1[19], message2[27], message3[14], message4[25], message5[19];
u64			startTick, currentTick;



void	colorful( void )
{
	colors[0] = 0x00000000;
	colors[1] = 0xffffffff;
	colors[2] = 0x00ff00ff;
	colors[3] = 0x00df00ff;
	colors[4] = 0x00bf00ff;
	colors[5] = 0x009f00ff;
	colors[6] = 0x007f00ff;
	colors[7] = 0x005f00ff;
	colors[8] = 0x003f00ff;
	colors[9] = 0x001f00ff;
	colors[10] = 0x000000ff;
	speed = 10;
	sprintf(message1, "There is no spoon.");
	sprintf(message2, "Welcome to the real world.");
	sprintf(message3, "Wake up, Neo");
	sprintf(message4, "Follow the white rabbit.");
	sprintf(message5, "Knock, Knock, Neo.");
	mode = 0;
}

void	clearBoard( void )
{
	int	x, y;
	for( x=0; x<67; x++ ) {
		for( y=0; y<34; y++ ) {
			board[x][y][0] = 0;
			board[x][y][1] = 0;
		}
		down[x] = 0;
		oneHere[x] = 0;
	}
}

void	fillLine( int thisLine )
{
	int	i, j;
	if( mode==0 ) {
		j = (rand() % (10));
		if( j == 1 ) {
			j = (rand() % (5));
			if( j==0 ) {
				for( i=0; i<2; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
				for( i=2; i<20; i++ ) {
					board[thisLine][i][0] = message1[i-2];
				}
				for( i=20; i<34; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
			} else if( j==1 ) {
				for( i=0; i<2; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
				for( i=2; i<28; i++ ) {
					board[thisLine][i][0] = message2[i-2];
				}
				for( i=28; i<34; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
			} else if( j==2 ) {
				for( i=0; i<2; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
				for( i=2; i<15; i++ ) {
					board[thisLine][i][0] = message3[i-2];
				}
				for( i=15; i<34; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
			} else if( j==3 ) {
				for( i=0; i<2; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
				for( i=2; i<26; i++ ) {
					board[thisLine][i][0] = message4[i-2];
				}
				for( i=26; i<34; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
			} else {
				for( i=0; i<2; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
				for( i=2; i<20; i++ ) {
					board[thisLine][i][0] = message5[i-2];
				}
				for( i=20; i<34; i++ ) {
					board[thisLine][i][0] = (rand() % (253)) + 1;
				}
			}
		} else {
			for( i=0; i<34; i++ ) {
				board[thisLine][i][0] = (rand() % (253)) + 1;
			}
		}
	} else if( mode==1 ) {
		for( i=0; i<34; i++ ) {
			board[thisLine][i][0] = (rand() % (26)) + 97;
		}
	} else {
		for( i=0; i<34; i++ ) {
			board[thisLine][i][0] = (rand() % (10)) + 48;
		}
	}
	board[thisLine][0][1] = 1;
}

void	clearLine( int thisLine )
{
	if( board[thisLine][down[thisLine]][1] == 10 ) {
		board[thisLine][down[thisLine]][0] = 0;
		board[thisLine][down[thisLine]][1] = 0;
		down[thisLine] = 0;
		oneHere[thisLine] = 0;
	} else {
		board[thisLine][down[thisLine]][0] = 0;
		board[thisLine][down[thisLine]][1] = 0;
		down[thisLine]++;
	}
}

void	createOne( void )
{
	int	i;
	i = rand() % (85);
	if( i<67 ) {
		if( oneHere[i] == 0 ) {
			fillLine(i);
			oneHere[i] = 1;
		}
	}
}

void	moveEveryoneDown( void )
{
	int	x, y;
	for( y=33; y>=0; y-- ) {
		for( x=0; x<67; x++ ) {
			if( board[x][y][1] == 1 ) {
				if( y==31 ) {
					board[x][y][1] = ( (rand() % (8)) + 2);
					board[x][y+1][1] = 10;
					clearLine( x );
				} else if( y>26 ) {
					if( ( rand() % 4 ) == 1 ) {
						board[x][y][1] = ( (rand() % (8)) + 2);
						board[x][y+1][1] = 10;
						clearLine( x );
					} else {
						board[x][y][1] = ( (rand() % (8)) + 2);
						board[x][y+1][1] = 1;
					}
				} else {
					board[x][y][1] = ( (rand() % (8)) + 2);
					board[x][y+1][1] = 1;
				}
			}
			if( board[x][y][1] == 10 ) {
				clearLine( x );
			}
		}
	}
	createOne();
}

void	drawEveryone( void )
{
	int	x, y;
	for( y=1; y<34; y++ ) {
		for( x=0; x<67; x++ ) {
			if( board[x][y][0] == 0 ) {
				printHex(0x00000000, x, y, " ");
			} else {
				sprintf(myMessage, "%c", board[x][y][0]);
				printHex(colors[board[x][y][1]], x, y, myMessage);
			}
		}
	}
}


void	pauseScreen( void )
{
	oldButtons = pad.Buttons;
	int	finished;
	finished = FALSE;
	while( !finished ) {
		sceCtrlReadBufferPositive(&pad, 1);
		if( pad.Buttons != 0 ) {
			if( pad.Buttons != oldButtons ) {
				if( pad.Buttons & PSP_CTRL_CROSS ) {
					finished = TRUE;
				}
			}
		}
		oldButtons = pad.Buttons;
	}
}


int	main( int argc, char **argv )
{
	pspDebugScreenInit();
	SetupCallbacks();

	srand (time_seed ());
	clearBoard();
	colorful();
	int	exitGame = FALSE;
	sceRtcGetCurrentTick(&startTick);
	while( !exitGame ) {
		sceRtcGetCurrentTick(&currentTick);
		if( (currentTick - startTick) > speed*10000 ) {
			sceRtcGetCurrentTick(&startTick);
			moveEveryoneDown();
			drawEveryone();
		}
		sceCtrlReadBufferPositive(&pad, 1);
		if( pad.Buttons != 0 ) {
			if( pad.Buttons != oldButtons ) {
				if( pad.Buttons & PSP_CTRL_CROSS ) {
					pauseScreen();
				} else if( pad.Buttons & PSP_CTRL_RTRIGGER ) {
					if( speed==1 ) {
						speed = 25;
					} else {
						speed--;
					}
				} else if( pad.Buttons & PSP_CTRL_LTRIGGER ) {
					if( speed==25 ) {
						speed = 1;
					} else {
						speed++;
					}
				} else if( pad.Buttons & PSP_CTRL_SQUARE ) {
					if( mode == 2 ) {
						mode = 0;
					} else {
						mode++;
					}
				} else {
					exitGame = TRUE;
				}
			}
		}
		oldButtons = pad.Buttons;
	}

	//sceKernelSleepThread();
	sceKernelExitGame();
	return( 0 );
}
